<template>
  <Head title="Table" />

  <Layout>
    <div class="max-w-full mx-auto sm:px-2 lg:px-2">
      <div class="lg:flex lg:items-center lg:justify-between">
        <div class="flex-1 min-w-0">
          <!-- {/* Title Page */} -->
          <h2
            class="
              text-2xl
              font-semibold
              text-gray-700
              dark:text-gray-200
              sm:text-3xl sm:truncate
            "
          >
            Table
          </h2>
          <!-- {/* Breadcumb */} -->
          <div
            class="
              mt-1
              flex flex-col
              sm:flex-row sm:flex-wrap sm:mt-0 sm:space-x-6
            "
          >
            <ul class="flex text-gray-900 text-sm lg:text-base">
              <li class="inline-flex items-center">
                <Link :href="route('dashboard')">Dashboard</Link>
                <Icon
                  :name="`chevron-right`"
                  :style="`h-5 w-auto text-gray-400`"
                />
              </li>
              <li class="inline-flex items-center">
                <Link :href="route('table')" class="text-gray-500">
                  Table
                </Link>
              </li>
            </ul>
          </div>
        </div>
        <div class="mt-5 flex lg:mt-0 lg:ml-4"></div>
      </div>

      <div class="flex items-center justify-between mb-6">
        <div class="my-2 flex sm:flex-row flex-col">
          <div class="flex flex-row mb-1 sm:mb-0">
            <div class="relative">
              <select
                v-model="params.show"
                class="
                  appearance-none
                  h-full
                  rounded-l
                  border
                  block
                  w-full
                  bg-white
                  border-gray-400
                  text-gray-700
                  py-2
                  px-4
                  pr-8
                  leading-tight
                  focus:outline-none focus:bg-white
                "
              >
                <option value="5">5</option>
                <option value="10">10</option>
                <option value="20">20</option>
                <option value="50">50</option>
              </select>
            </div>
          </div>
          <div class="relative">
            <select
              v-model="params.verify"
              class="
                appearance-none
                h-full
                rounded-r
                border-t
                sm:rounded-r-none sm:border-r-0
                border-r border-b
                block
                w-full
                bg-white
                border-gray-400
                text-gray-700
                py-2
                px-4
                pr-8
                leading-tight
                focus:outline-none focus:border-l focus:border-r focus:bg-white
              "
            >
              <option value="all">All</option>
              <option value="onlyTrashed">Trashed</option>
            </select>
          </div>
          <div class="block relative">
            <span
              class="h-full absolute inset-y-0 left-0 flex items-center pl-2"
            >
              <svg
                viewBox="0 0 24 24"
                class="h-4 w-4 fill-current text-gray-500"
              >
                <path
                  d="M10 4a6 6 0 100 12 6 6 0 000-12zm-8 6a8 8 0 1114.32 4.906l5.387 5.387a1 1 0 01-1.414 1.414l-5.387-5.387A8 8 0 012 10z"
                ></path>
              </svg>
            </span>
            <Input
              v-model="params.search"
              placeholder="Search"
              class="
                appearance-none
                rounded-r rounded-l
                sm:rounded-l-none
                border border-gray-400 border-b
                block
                pl-8
                pr-6
                py-2
                w-full
                bg-white
                text-sm
                placeholder-gray-400
                text-gray-700
                focus:bg-white
                focus:placeholder-gray-600
                focus:text-gray-700
                focus:outline-none
              "
            />
          </div>
          <button
            class="
              ml-3
              text-sm text-gray-500
              hover:text-gray-700
              focus:text-indigo-500
            "
            type="button"
            @click="reset"
          >
            Reset
          </button>
        </div>
        <Link
          v-if="$page.props.auth.can.create_table"
          class="
            flex
            right-0
            items-center
            px-4
            py-2
            border border-transparent
            rounded-md
            shadow-sm
            text-sm
            font-medium
            text-white
            bg-yellow-600
            hover:bg-yellow-700
            focus:outline-none
            focus:ring-2
            focus:ring-offset-2
            focus:ring-yellow-500
          "
          :href="route('table.create')"
        >
          <Icon :name="`pencil-add`" :style="`-ml-1 mr-2 h-5 w-5`" />
          <span class="hidden md:inline">Create New</span>
        </Link>
      </div>

      <div class="w-full overflow-hidden rounded-lg shadow-xs">
        <div class="w-full overflow-x-auto">
          <table class="w-full whitespace-no-wrap">
            <thead>
              <tr
                class="
                  text-xs
                  font-semibold
                  tracking-wide
                  text-left text-gray-500
                  uppercase
                  border-b
                  bg-gray-100
                  dark:border-gray-700 dark:text-gray-400 dark:bg-gray-800
                "
              >
                <th class="px-4 py-3">
                  <span
                    @click="sortingBy('name')"
                    class="inline-flex w-full justify-between"
                    style="cursor: pointer"
                  >
                    Name
                    <Icon
                      v-if="params.field === 'name' && params.orderby === 'asc'"
                      :name="`ascending`"
                      :style="`flex ml-3  w-5 transform hover:text-gray-700 hover:scale-110`"
                    />

                    <Icon
                      v-if="
                        params.field === 'name' && params.orderby === 'desc'
                      "
                      :name="`descending`"
                      :style="`flex ml-3  w-5 transform hover:text-gray-700 hover:scale-110`"
                    />
                  </span>
                </th>
                <th class="px-4 py-3">Slug</th>
                <th class="px-4 py-3">Status</th>
                <th
                  v-if="
                    $page.props.auth.can.update_table ||
                    $page.props.auth.can.delete_table
                  "
                  class="px-4 py-3 text-center w-40"
                >
                  Action
                </th>
              </tr>
            </thead>
            <tbody
              class="bg-white divide-y dark:divide-gray-700 dark:bg-gray-800"
            >
              <tr
                v-for="table in tables.data"
                :key="table.id"
                class="text-gray-700 dark:text-gray-400"
              >
                <td class="px-4 py-3">
                  <p class="font-semibold">{{ table.name }}</p>
                </td>
                <td class="px-4 py-3">
                  <div class="flex items-center text-sm">
                    <div>
                      <p class="font-semibold">{{ table.slug }}</p>
                    </div>
                  </div>
                </td>
                <td class="px-4 py-3 text-xs">
                  <span
                    v-if="table.deleted_at === null"
                    class="
                      px-2
                      py-1
                      font-semibold
                      leading-tight
                      text-green-700
                      bg-green-100
                      rounded-full
                      dark:bg-green-700 dark:text-green-100
                    "
                  >
                    Active
                  </span>

                  <span
                    v-if="table.deleted_at"
                    @click="setActiveModalConfirmOpen(true, table.id)"
                    style="cursor: pointer"
                    class="
                      px-2
                      py-1
                      font-semibold
                      leading-tight
                      text-red-700
                      bg-red-100
                      rounded-full
                      dark:text-white dark:bg-red-600
                    "
                  >
                    Disable
                  </span>
                </td>
                <td
                  v-if="
                    $page.props.auth.can.update_table ||
                    $page.props.auth.can.delete_table
                  "
                  class="px-4 py-3 text-center"
                >
                  <div
                    class="flex item-center justify-center"
                    v-if="table.deleted_at == null"
                  >
                    <Link
                      v-if="$page.props.auth.can.update_table"
                      :href="route('table.edit', table.id)"
                      class="
                        w-5
                        mr-2
                        transform
                        hover:text-yellow-500 hover:scale-110
                      "
                    >
                      <Icon
                        :name="`pencil-edit`"
                        :style="`w-5 mr-2 transform hover:text-yellow-500 hover:scale-110`"
                      />
                    </Link>
                    <button
                      v-if="$page.props.auth.can.delete_table"
                      @click="setIsOpen(true, table.id)"
                      class="
                        w-5
                        mr-2
                        text-right
                        transform
                        hover:text-red-500 hover:scale-110
                      "
                    >
                      <Icon
                        :name="`trash`"
                        :style="`w-5 mr-2 text-right transform hover:text-red-500 hover:scale-110`"
                      />
                    </button>
                  </div>
                </td>
              </tr>
              <tr v-if="tables.data.length === 0">
                <td class="border-t px-6 py-4" colspan="4">No Table found.</td>
              </tr>
            </tbody>
          </table>
        </div>

        <!-- Pagination -->
        <Pagination
          :links="tables.links"
          :from="tables.from"
          :to="tables.to"
          :total="tables.total"
        />

        <!-- Pagination -->

        <ModalConfirm
          ref="modalConfirm"
          :title="`Delete Data Table`"
          :message="`Are you sure you want to delete this data? This action cannot be undone.`"
          :showModal="isOpen"
          :titleActionButton="`Deactivate`"
          :styleBgIcon="`mx-auto flex-shrink-0 flex items-center justify-center h-12 w-12 rounded-full bg-red-100 sm:mx-0 sm:h-10 sm:w-10`"
          :styleTextIcon="`h-6 w-6 text-red-600`"
          :styleButtonAction="`w-full inline-flex justify-center rounded-md border border-transparent shadow-sm px-4 py-2 bg-red-600 text-base font-medium text-white hover:bg-red-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-red-500 sm:ml-3 sm:w-auto sm:text-sm`"
          :closeModal="closeModal"
          @onConfirm="onConfirmDelete"
        />

        <ModalConfirm
          ref="modalConfirm"
          :title="`Active Data Table`"
          :message="`Are you sure you want to active this data?`"
          :showModal="isOpenActiveModalConfirm"
          :titleActionButton="`Set Active`"
          :styleBgIcon="`mx-auto flex-shrink-0 flex items-center justify-center h-12 w-12 rounded-full bg-gray-100 sm:mx-0 sm:h-10 sm:w-10`"
          :styleTextIcon="`h-6 w-6 text-gray-600`"
          :styleButtonAction="`w-full inline-flex justify-center rounded-md border border-transparent shadow-sm px-4 py-2 bg-gray-600 text-base font-medium text-white hover:bg-gray-700 focus:outline-none focus:ring-2 focus:ring-offset-2 focus:ring-gray-500 sm:ml-3 sm:w-auto sm:text-sm`"
          :closeModal="closeModalConfirmActive"
          @onConfirm="onConfirmActiveSubmit"
        />
      </div>
    </div>
  </Layout>
</template>

<script>
import { ref, reactive } from "vue";
import Layout from "@/Layouts/App.vue";
import { Head, Link, usePage } from "@inertiajs/inertia-vue3";
import { Inertia } from "@inertiajs/inertia";
import Icon from "@/Components/Icon";
import Input from "@/Components/Input.vue";
import Pagination from "@/Components/Pagination.vue";
import ModalConfirm from "@/Components/Modal/ModalConfirm.vue";
import pickBy from "lodash/pickBy";
import throttle from "lodash/throttle";

export default {
  components: {
    Layout,
    Head,
    Link,
    Input,
    Pagination,
    ModalConfirm,
    Inertia,
    Icon,
  },
  props: {
    tables: Object,
    filters: Object,
  },
  setup(props) {
    let isOpen = ref(false);
    let isOpenActiveModalConfirm = ref(false);
    let tableId = ref(null);

    let params = reactive({
      show: props.filters.show || "5",
      search: props.filters.search,
      verify: props.filters.verify || "all",
      field: props.filters.field || "name",
      orderby: props.filters.orderby || "asc",
    });

    let onConfirmDelete = () => {
      Inertia.delete(route("table.destroy", tableId.value), {
        onSuccess: () => {
          isOpen.value = false;
        },
      });
    };

    let onConfirmActiveSubmit = () => {
      Inertia.get(route("table.restore", tableId.value), {
        onSuccess: () => {
          isOpenActiveModalConfirm.value = false;
        },
      });
    };

    let reset = () => {
      //   params.value = mapValues(params.value, () => null);
      params.verify = "all";
      params.show = "5";
      params.search = "";
      params.field = "name";
      params.orderby = "asc";
    };

    return {
      params,
      isOpen,
      isOpenActiveModalConfirm,
      onConfirmDelete,
      onConfirmActiveSubmit,
      reset,
      setIsOpen(value, id) {
        isOpen.value = value;
        tableId.value = id;
      },
      setActiveModalConfirmOpen(value, id) {
        // console.log(value, id)
        isOpenActiveModalConfirm.value = value;
        tableId.value = id;
      },
      closeModal() {
        isOpen.value = false;
      },
      closeModalConfirmActive() {
        isOpenActiveModalConfirm.value = false;
      },
      sortingBy(field) {
        params.field = field;
        params.orderby = params.orderby === "asc" ? "desc" : "asc";
      },
    };
  },
  watch: {
    params: {
      deep: true,
      handler: throttle(function () {
        let params = this.params;
        this.$inertia.get(this.route("table"), pickBy(params), {
          preserveState: true,
        });
      }, 250),
    },
  },
};
</script>
